import javax.swing.*;
import java.awt.Container;
/**
 * Clase principal del applet del laboratorio de elementos fisicos.
 */
public class PhysicsLabApplet extends JApplet{

    /**
     * Metodo que implementa la clase principal del applet del laboratorio de elementos fisicos.
     */



   public void init(){

      GraphPanel graphPanel = new GraphPanel();
      BlockSpringConfiguration bsConfig = new BlockSpringConfiguration();
      LabPanel labPanel = new LabPanel(bsConfig);
      graphPanel.setAlignmentY(LEFT_ALIGNMENT);
      JSplitPane splitPane = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT, labPanel, graphPanel);
      splitPane.setDividerLocation(this.getWidth()-200);
      bsConfig.setLabPanel(labPanel);   // to repaint view when model changes
      LabMenuBar menuBar = null;
      InsertElementListener ieListener = new InsertElementListener(bsConfig);
      Simulator sim = new Simulator(bsConfig,graphPanel);
      SelectListener selListener = new SelectListener(sim);
      SimulatorListener sListener = new SimulatorListener(sim,graphPanel);
      menuBar = new LabMenuBar(ieListener, sListener,selListener);
      ieListener.setMenu(menuBar);
      MouseListener mListener = new MouseListener(bsConfig, labPanel, selListener);
      labPanel.addMouseMotionListener(mListener);
      labPanel.addMouseListener(mListener);
      Container contentPane = getContentPane();
      contentPane.add(splitPane);
      setJMenuBar(menuBar);
                
      String refresh = getParameter("RefreshTime");
      String delta = getParameter("DeltaTime");
      String time = getParameter("timeWindowSize");
      String g = getParameter("Gravity");
      NumberFormatException b = new NumberFormatException("Negative number");

      try{
          if(Float.parseFloat(delta) > 0){
              sim.setDelta_t(Float.parseFloat(delta));
          } else throw(b);
      } catch (NumberFormatException a){
                     JOptionPane.showMessageDialog(this, "Invalid parameter found for delta time, using default value", "Error", JOptionPane.ERROR_MESSAGE);
      } catch (NullPointerException a){
      }

      try{
          if(Float.parseFloat(refresh) > 0){
              sim.setSamplingPeriod(Float.parseFloat(refresh));
          } else throw(b);
      } catch (NumberFormatException a){
                     JOptionPane.showMessageDialog(this, "Invalid parameter found for refresh time, using default value", "Error", JOptionPane.ERROR_MESSAGE);
      } catch (NullPointerException a){
      }

      try{
          if(Double.parseDouble(time) > 0){
              graphPanel.setMaxTime(Double.parseDouble(time));
          } else throw(b);
      } catch (NumberFormatException a){
                     JOptionPane.showMessageDialog(this, "Invalid parameter found for max time, using default value", "Error", JOptionPane.ERROR_MESSAGE);
      } catch (NullPointerException a){
      }

      try{
          if(Double.parseDouble(g) > 0){
              sim.setGravity(Float.parseFloat(g));
          } else throw(b);
      } catch (NumberFormatException a){
                     JOptionPane.showMessageDialog(this, "Invalid parameter found for gravity, using default value", "Error", JOptionPane.ERROR_MESSAGE);
      } catch (NullPointerException a){
      }
      


   }    
}

