import java.awt.event.*;
import javax.swing.*;
/**
 * Clase que implementa la seccion de elementos a graficar.
 */
public class SelectListener implements ActionListener {
   private Simulator simulator;
   private boolean runflag = false;
   private boolean flag = false;

    /**
    * Constructor para SelectListener
    * @param sim Simulador en el cual se selecciona el bloque.
    */
   public SelectListener (Simulator sim){
      simulator = sim;
   }

   /**
    * Accion a seguir al producirse un evento en el menu de seleccion.
    * @param e Evento capturado desde el menu de simlacion
    */
   public void actionPerformed(ActionEvent e) {
      JMenuItem menuItem = (JMenuItem)(e.getSource());
      String text = menuItem.getText();
      if (text.equals("From panel")){
          if(simulator.isRunning()){
              simulator.stop();
              runflag = true;
          }
          flag = true;
      }
      else{
          for (int i=0; i < simulator.numBlocks();i++){
            if (text.equals("Mass "+i))
                simulator.setBlock(i);
          }
      }
   }
   /**
    * Si en el menu se selecciono "From Panel", este metodo seleciona el bloque y reinicia la simulacion.
    */
   public void blockClicked(Block block){
       if(flag){
           if(runflag){
                simulator.start();
                runflag = false;
           }
           simulator.setBlock(block.getId());
           flag = false;
       }
   }
}